/*
 * @(#)OGPropInstance.java
 *
 * Ontology Graph API,  Copyright 2000, 2001 GRCI All Rights Reserved.
 *
 */
package com.att.gs.codip.ograph;

/**
 * Provides instances of Property.
 *
 **/
public interface OGInstance  {

/*
 * ---------- Basic Access Methods --------------
 */
 /**
 * Getter method for the Resources ID.

 * The resource ID is unique and immutable once created. Currently
 * the ID is the resources URI.
 *
 * @returns The ID as a String.
 **/
public String getID ();

/**
 * Getter method for this instance's object resource.
 *
 * @returns  The resource that is the object of this instance.
 **/
public OGResource getObject();

/**
 * Getter method for this instance's property resource.
 *
 * @returns  The resource that is the type of the instance's underlying resource.
 **/
public OGResource getProperty();


/**
 * Getter method for this instance's subject resource.
 *
 * @returns The resource that is the subject of this instance.
 **/
public OGResource getSubject();


}
