/*
 * @(#)OGPropInstance.java
 *
 * Ontology Graph API,  Copyright 2000, 2001 GRCI All Rights Reserved.
 *
 */
package com.att.gs.codip.ograph;


/**
 * Provides instances of Property.
 *
 * The object and subject of each instance are used analogously to
 * object and subject in RDF. That is the subject resource has this
 * property, whose value is object.
 *
 **/
public interface OGPropInstance extends OGProperty {

/*
 * ---------- Basic Access Methods --------------
 */

/**
 * Setter method for this properties object resource.
 *
 * @param theObject The resource that is the value of this property.
 **/
public void setObject(OGResource theObject);

/**
 * Getter method for this properties object resource.
 *
 * @returns  The resource that is the value of this property.
 **/
public OGResource getObject();


/**
 * Setter method for this properties subject resource.
 *
 * @param theSubject The resource that has this property.
 **/
public void setSubject(OGResource theSubject);

/**
 * Getter method for this properties subject resource.
 *
 * @returns The resource that has this property.
 **/
public OGResource getSubject();


}
