/*
 * FileSystem.java
 *
 * Created on June 15, 2004, 11:22 PM
 */

package cz.cvut.km.io;

import cz.cvut.km.model.*;
import java.io.*;

/**
 *
 * @author  aubrech
 */
public class FileSystem implements IoInterface {
    public static final String NS = "filesystem";
    
    // process only directories
    protected boolean onlyDirs = false;
    
    /** Creates a new instance of FileSystem */
    public FileSystem() {
    }
    
    /**
     * save a knoledge base
     */
    public void saveKB(cz.cvut.km.model.KnowledgeBase kb, java.util.Properties parameters) throws java.io.IOException, cz.cvut.km.utils.KMException {
        throw new cz.cvut.km.utils.NotImplementedException();
    }
    
    /**
     * load a knowledge base from the I/O module
     */
    public cz.cvut.km.model.KnowledgeBase loadKB(java.util.Properties parameters) throws java.io.IOException, cz.cvut.km.utils.KMException {
        KnowledgeBase kb = new KnowledgeBase();
        kb.addSystemNamespace(NS);
        File root = new File(parameters.get("root").toString());
        Object onlyDirsParam = parameters.get("onlyDirs");
        if(onlyDirsParam!=null && onlyDirsParam.toString().equals("true"))
            onlyDirs = true;
        processFile(kb,null,root);
        return kb;
    }
    
    protected void processFile(KnowledgeBase kb, Concept parentConcept, File dir) {
        System.out.println("Processing "+dir.getAbsolutePath());
        Concept thisDir = new Concept(NS,dir.getAbsolutePath());
        thisDir.setCaption(dir.getName());
        kb.addConcept(thisDir);
        if(parentConcept!=null)
            kb.addRelation(new SubclassOf(parentConcept,thisDir));
        if(dir.isDirectory()) {
            // process all visible files/directories
            File subdirs[] = dir.listFiles(new FileFilter() {
                public boolean accept(File pathname) {
                    if(onlyDirs && pathname.isFile())
                        return false;
                    return !pathname.isHidden();
                }
            });
            if(subdirs!=null) {
                for(int i=0;i<subdirs.length;i++) {
                    processFile(kb,thisDir,subdirs[i]);
                }
            }
        }
    }
    
    public boolean supports(String action) {
        return action.equals(SUPPORTS_LOAD);
    }
    
}
