/*
 * Prefuse.java
 *
 * Created on July 1, 2004, 11:18 AM
 */

package cz.cvut.km.io;

import cz.cvut.km.model.*;
import cz.cvut.km.utils.*;
import java.io.*;
import java.util.*;

import org.w3c.dom.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

/**
 * Visualise using prefuse (http://prefuse.sourceforge.net)
 * @author  aubrech
 */
public class Prefuse implements IoInterface {
    
    /** Creates a new instance of hypergraph */
    public Prefuse() {
    }
    
    public cz.cvut.km.model.KnowledgeBase loadKB(java.util.Properties parameters) throws java.io.IOException, cz.cvut.km.utils.KMException {
        throw new NotImplementedException();
    }
    
    public void saveKB(cz.cvut.km.model.KnowledgeBase kb, java.util.Properties parameters) throws java.io.IOException, cz.cvut.km.utils.KMException {
        try {
            File file = new File(parameters.getProperty("filename","test.xml"));
            Document doc = DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument();
            
            Element graph = doc.createElement("graph");
            graph.setAttribute("directed", "0");
            doc.appendChild(graph);
            
            Iterator itC = kb.getConcepts();
            while(itC.hasNext()) {
                Concept c = (Concept)itC.next();
                Element node = doc.createElement("node");
                node.setAttribute("id", c.toString());
                node.setAttribute("label", c.getCaption());
                graph.appendChild(node);
            }
            
            Iterator itR = kb.getRelations();
            while(itR.hasNext()) {
                Relation r = (Relation)itR.next();
                Element edge = doc.createElement("edge");
                edge.setAttribute("source", r.getSource().toString());
                edge.setAttribute("target", r.getTarget().toString());
                graph.appendChild(edge);
            }

            // save the XML
            Source source = new DOMSource(doc);
            Result result = new StreamResult(file);
            Transformer xformer = TransformerFactory.newInstance().newTransformer();
            xformer.setOutputProperty(OutputKeys.INDENT,"yes");
            xformer.transform(source, result);
        } catch(Exception e) {
            throw new KMException(e.getMessage(),e);
        }
        
    }
    
    public boolean supports(String action) {
        return action.equals(SUPPORTS_SAVE);
    }
    
}
