/*
 * GraphViz.java
 *
 * Created on May 5, 2004, 1:33 PM
 */

package cz.cvut.km.io;

import cz.cvut.km.model.*;
import cz.cvut.km.model.iterators.*;

import java.io.*;
import java.util.*;

/**
 *
 * @author  aubrech
 */
public class Prolog implements IoInterface {
    
    /** Creates a new instance of GraphViz */
    public Prolog() {
        
    }
    
    /**
     * load a knowledge base from the I/O module
     */
    public cz.cvut.km.model.KnowledgeBase loadKB(java.util.Properties parameters) throws java.io.IOException, cz.cvut.km.utils.KMException {
        throw new cz.cvut.km.utils.NotImplementedException();
    }
    
    /**
     * save a knoledge base
     */
    public void saveKB(cz.cvut.km.model.KnowledgeBase kb, java.util.Properties parameters) throws java.io.IOException, cz.cvut.km.utils.KMException {
        String filename = (String)parameters.getProperty("filename");
        String headers = (String)parameters.getProperty("headers","");
        //boolean showNS = ((String)parameters.getProperty("showNS","true")).equalsIgnoreCase("true");
        PrintWriter pw = new PrintWriter(new FileWriter(filename));
        
        pw.println("% generated by BabelFish, module Prolog, author Petr Aubrecht, CTU in Prague");
        pw.println("% "+new java.util.Date().toString());
        pw.println();
        pw.println(headers);
        pw.println();
        ConceptIterator it = kb.getConcepts();
        while(it.hasNext()) {
            Concept c = it.nextConcept();
            pw.println("concept('"+c.toString()+"').");
        }
        pw.println();
        RelationIterator rels = kb.getRelations();
        while(rels.hasNext()) {
            Relation r = rels.nextRelation();
            String pred = r.getClass().getName().toLowerCase();
            int lastDot = pred.lastIndexOf(".");
            pred = pred.substring(lastDot+1);
            pw.println("relation("+pred+",'"+r.getSource().toString()+"', '"+r.getTarget().toString()+"').");
        }
        pw.close();
    }
    
    public boolean supports(String action) {
        return action.equals(SUPPORTS_SAVE);
    }
    
}
