/*
 * Vrml.java
 *
 * Created on July 1, 2004, 11:18 AM
 */

/*
 * TODO:-aby spojnici slo chytit a otacet celym stromem
 * 		-sesikmeni spojnice aby ukazovala od rodice k potomkovi
 *  	-verzi pro xj3d ktera by nevyuzivala uzel bilboard?
 * 		-viewpointy ke kazdemu rozbalenemu/rozbalitelnemu viditelnemu uzlu
 */

package cz.cvut.km.io;

import java.io.File;
import java.io.PrintWriter;
import java.util.Calendar;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;

import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;

import cz.cvut.km.model.Concept;
import cz.cvut.km.model.Relation;
import cz.cvut.km.utils.KMException;
import cz.cvut.km.utils.NotImplementedException;

/**
 * Visualise using Vrml (http://Vrml.sourceforge.net)
 * @author  aubrech
 */
public class Vrml implements IoInterface {
    /** Creates a new instance of hypergraph */
    public Vrml() {
    }
    
    public cz.cvut.km.model.KnowledgeBase loadKB(java.util.Properties parameters) throws java.io.IOException, cz.cvut.km.utils.KMException {
        throw new NotImplementedException();
    }
    
    public void saveKB(cz.cvut.km.model.KnowledgeBase kb, java.util.Properties parameters) throws java.io.IOException, cz.cvut.km.utils.KMException {
        try {
            File file = new File(parameters.getProperty("filename","test.wrl"));
            Document doc = DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument();
            
 /*           
            Element graph = doc.createElement("graph");
            graph.setAttribute("directed", "0");
            doc.appendChild(graph);
            
            Iterator itC = kb.getConcepts();
            while(itC.hasNext()) {
                Concept c = (Concept)itC.next();
                Element node = doc.createElement("node");
                node.setAttribute("id", c.toString());
                node.setAttribute("label", c.getCaption());
                graph.appendChild(node);
            }
            
            Iterator itR = kb.getRelations();
            while(itR.hasNext()) {
                Relation r = (Relation)itR.next();
                Element edge = doc.createElement("edge");
                edge.setAttribute("source", r.getSource().toString());
                edge.setAttribute("target", r.getTarget().toString());
                graph.appendChild(edge);
            }
*/
            VRMLTree strom=new VRMLTree();
            Iterator itC = kb.getConcepts();            
            while(itC.hasNext()) {
            	Concept c= (Concept)itC.next();
            	strom.addConcept(c);            	
            }
            
            Iterator itR = kb.getRelations();
            while(itR.hasNext()) {
            	Relation r = (Relation)itR.next();
           		strom.addRelation(r); //zde muze byt hozena vyjimka - odchycena nize.
            }
            
            strom.findRoot();
            strom.createOrdering();
            PrintWriter fw=new PrintWriter(file);
            fw.println(header(file.getName()) + strom.VRMLRepresentation() + footer());
            fw.close();
            // ****************** az sem

            // save the XML
           /* Source source = new DOMSource(doc);
            Result result = new StreamResult(file);
            Transformer xformer = TransformerFactory.newInstance().newTransformer();
            xformer.setOutputProperty(OutputKeys.INDENT,"yes");
            xformer.transform(source, result);*/
            
        } catch(Exception e) {
            throw new KMException(e.getMessage(),e);
        }
        
    }

    private String footer() {
    	return new String("}");
    }
    
    private String header(String fileName) {
    	Calendar c=Calendar.getInstance();
    	return new String("#VRML V2.0 utf8\n" +
    			"#Id: "+fileName + c.get(Calendar.YEAR) +"/"+c.get(Calendar.MONTH)+"/"+c.get(Calendar.DAY_OF_MONTH)+ 
				" " + c.get(Calendar.HOUR_OF_DAY)+":"+c.get(Calendar.MINUTE)+":"+c.get(Calendar.SECOND)+
				"\n#Created by ---== Sumatra2 VRML Generator ==---\n" +
				"#Authors: Jan Simacek & Jakub Holy, FEL CVUT Praha" + "\n\n"+

				"NavigationInfo {\n" +
				"	headlight TRUE\n" +
				"}\n\n" +
				"Background {\n"+
				"	skyColor [0 0 0, .1 .1 .1, .4 .4 .4, .5 .5 .5] #.6 1 .7\n"+ 
				"	skyAngle [.1 .2 1.3]\n"+
				"	groundColor .3 0.2 .1\n"+
				"	groundAngle [1.57]\n"+
				"	}\n\n"+
				"EXTERNPROTO Uzel [\n"+
				"		field	SFInt32 myLevel\n"+
				"		field	SFRotation rotation			# odklon hrany k predkovi od osy Y\n"+ 
				"		field 	SFInt32 is_children_visible # -1; 0 = true, -1 = false; inic. nastaveni viditelnosti !!! skript o tom nevi!\n"+
				"		field 	SFInt32 is_edge_visible		# 0; je viditelna spojnice k predkovi? k pouziti pro 1. koren stromu\n"+
				"		field 	MFString popis_uzlu\n"+
				"		field 	SFColor barva_uzlu\n"+
				"		field	 MFNode potomci\n"+
				"		eventIn SFInt32 set_predcessor_changed_id\n"+
				"		eventOut SFInt32 get_predcessor_changed_id\n"+
				"	]\n"+
				"\"prototypy.wrl#Uzel\"\n\n"+
		"DEF SVETLO DirectionalLight {\n"+
    	"	color .7 .7 .7\n"+
    	"	direction 0 0 -1\n"+
    	"	}\n\n"+

    	"DEF V_HLAVNI Viewpoint {\n"+
    	"	position 0 5 0\n"+
    	"	orientation 1 0 0 -1.5708\n"+
    	"	description \"Vychozi\"\n"+
    	"	}\n\n"+
    	"Transform {\n"+
    	"	translation 0 -5 0	# - vychozi posunuti uzlu\n"+
    	"	children\n");
    }
    
    public boolean supports(String action) {
        return action.equals(SUPPORTS_SAVE);
    }
            
    /**
     * Vnitrni trida reprezentujici uzel stromu ktery si tvorime pro snadnejsi
     * generovani VRML kodu.
     * @author sima
     */
    private class VRMLNode {
    	/** Cislo potomka - vyuzivam pri vypoctu VRML pole rotation */
    	public int number;
    	/** Ukazatel na prislusny koncept, ktery dany uzel reprezentuje */
    	public Concept label;    	
    	/** Rodicovsky uzel */
    	public VRMLNode parent;
    	/** Seznam potomku */
    	public Collection children;
    	
    	public int mojeRovina,mojeCisloVRovine;
    	
    	/**
    	 * Konstruktor - pouze inicializuje promenne.
    	 * @param l Koncept, ktery dany uzel reprezentuje
    	 * @param p Rodic
    	 * @param c Seznam potomku
    	 */
    	public VRMLNode(Concept l, VRMLNode p, Collection c) {    		
    		label=l;
    		parent=p;
    		children=c;
    	}
    	
    	/** 
    	 * Ocisluje svoje potomky. Poradi cislovani nema vyznam, je to jenom kvuli
    	 * jejich rozvrzeni do prostoru -- vypocet VRML pole rotation
    	 */
    	public void numberChildren() {
    		if(children!=null) {
    			Iterator it=children.iterator();   		
    			int i=0;
    			while (it.hasNext()) {
					VRMLNode dite = (VRMLNode) it.next();
					dite.number=i++;
					dite.numberChildren();
				}
    		}
    	}
    	/**
    	 * Generuje string obsahujici dany pocet tabulatoru (kvuli identation)
    	 * @param n Kolik tabulatoru chci mit ve vystupu
    	 * @return String obsahujici n krat znak '\t'
    	 */
    	private String tabs(int n) {
    		if(n==0) return new String("");
    		char[] r=new char[n];
    		for (int i = 0; i < r.length; i++) {
				r[i]='\t';
			}
    		return new String(r);
    	}
    	/**
    	 * Vypocte pro tento uzel hodnotu rotace (zavisi na poctu sourozencu a na cisle
    	 * daneho uzlu.
    	 * @return VRMLPole rotation ve tvaru 'x y z value'=vektor osy otaceni, a uhel otoceni
    	 */
    	private String rotation() {
    		int sourozencu=parent.children.size(); //pocet sourozencu
    		int pocetRovin, uzluVRovine;
    		if(sourozencu<=8) {pocetRovin=sourozencu; uzluVRovine=1;}
    		else {
    			pocetRovin=8;
    			uzluVRovine=(int)Math.ceil(1.0*sourozencu/pocetRovin);
    		}
    		mojeRovina=number/uzluVRovine;
    		mojeCisloVRovine=number % uzluVRovine;
    		
    		double phi=2*Math.PI/(pocetRovin+((parent.parent==null)?1:0)); //uhel mezi rovinami
    		double xi=2*Math.PI/(((parent.parent==null)?1:2)*((uzluVRovine*2)+2)); //uhel mezi uzly v ramci roviny
    		return new String(/*"rovina="+mojeRovina +" cislo=" + mojeCisloVRovine+
    				" rotace: " +*/(float)Math.sin(mojeRovina*phi)+" 0 "+ (float)Math.cos(mojeRovina*phi)+
					" " + (float)(mojeCisloVRovine+1)*xi);
    	}
    	
    	/**
    	 * Vrati VRML reprezentaci daneho uzlu a vsech jeho potomku jako string.
    	 * @param tabsCount O kolik tabulatoru se ma odsazovat (aby byl kod prehledny) 
    	 * tento uzel. Vsichni jeho primi potomci budou odsazeni o jeden tabulator navic,
    	 * jejich potomci o dalsi atd. Tj zaroven je vyuzit jako indikator urovne uzlu.
    	 * @return VRML kod vizualizujici podstrom s korenem v danem uzlu.
    	 */
    	public String VRMLRepresentation(int tabsCount) {
    		String ret;
    		if(parent==null) { //root uzel
    			ret=new String("DEF "+label.getName()+" Uzel {\n  myLevel 0\n  is_edge_visible -1\n  popis_uzlu [\""+
    					label.getName()+"\"]\n");    			
    		}
    		else { //ostatni uzly
    			ret=new String(tabs(tabsCount)+"DEF "+label.getName()+" Uzel {\n"+
    					tabs(tabsCount)+"  ROUTE "+parent.label.getName()+".get_predcessor_changed_id TO "+label.getName()+".set_predcessor_changed_id\n"+
						tabs(tabsCount)+"  myLevel "+tabsCount + "\n"+tabs(tabsCount)+ "  rotation "+ rotation() +"\n" +
						tabs(tabsCount)+"  popis_uzlu [\""+label.getName()+"\"]\n");
    		}
    		if(children!=null) {
    			ret=new String(ret + tabs(tabsCount)+ "  potomci [\n");
    			Iterator it=children.iterator();
    			while(it.hasNext()) 
    				ret=new String(ret + ((VRMLNode)it.next()).VRMLRepresentation(tabsCount+1));
    			ret=new String(ret + tabs(tabsCount)+"  ]\n");
    		}
    		else { //list!
    			ret=new String(ret + tabs(tabsCount)+"  barva_uzlu 0.188 0.513 1\n");
    		}
    		ret=new String(ret +tabs(tabsCount)+ "}\n");
    		return ret;
    	}
    	
    	/**
    	 * Jenom vypise obsah stromu na stdout.
    	 */
    	public void dump(int tabLevel) {
    		System.out.println(tabs(tabLevel)+"uzel name="+label.getName()+" cislo="+ number +" potomci: ");
    		if(children!=null) {
    			Iterator it = children.iterator();    		
    			while(it.hasNext()) {
    				((VRMLNode)it.next()).dump(tabLevel+1);
    			}
    		}
    	}
    }
    
    /**
     * Vnitrni trida reprezentujici strom vygenerovany z konceptu a relaci ulozenych v kb.
     * @author sima
     */
    private class VRMLTree {
    	/** Koren stromu */
    	public VRMLNode root;
    	/** Hash mapa polozek: klic=koncept, hodnota=odpovidajici uzel stromu */
    	private HashMap concepts;
    
    	/**
    	 * Konstruktor - koren stromu nastavi na null a vytvori prazdnou hash mapu polozek.
    	 */
    	public VRMLTree() {
    		root=null;
    		concepts=new HashMap();
    	}
    	/**
    	 * Ocisluje vzestupne od nuly vsechny uzly v kazde urovni. Toto cislovani je vyuzito
    	 * pri vypoctu VRML pole rotation.
    	 */
    	public void createOrdering() {
    		if(root!=null) {
    			root.number=0;
    			root.numberChildren();
    		}
    	}
    	
    	/**
    	 * Prida koncept do utvareneho stromu, tj. vytvori pouze uzel bez rodice a bez
    	 * potomku (nastaveny na null).
    	 * @param c Koncept reprezentovany danym uzlem.
    	 */
    	public void addConcept(Concept c) {
    		concepts.put(c,new VRMLNode(c, null, null));
    	}
    	/**
    	 * Prida relaci do utvareneho stromu. POZOR! - nejprve je nutne pridat vsechny
    	 * koncepty, nez je pridana prvni relace!
    	 * @param r Realce ktera se ma pridat
    	 * @throws Exception Hozena, pokud ve stromu neni cil nebo zdroj relace r.
    	 */
    	public void addRelation(Relation r) throws Exception {
    		VRMLNode child=(VRMLNode)concepts.get(r.getSource());
    		VRMLNode par=(VRMLNode)concepts.get(r.getTarget());
    		if (child!=null && par!=null) {
    			child.parent=par;
    			if(par.children==null)
    				par.children=new HashSet();
    			par.children.add(child);
				
    		}
    		else 
    			throw new Exception("Source or destination concept of a relation not found in this VRMLTree.");
    	}
    	
    	/**
    	 * Nalezeni korene zkonstruovaneho stromu. Od prvniho uzlu v hash mape concepts se 
    	 * vyda po predcich az k uzlu ktery nema predka a ten vrati nastavi jako koren
    	 * stromu (promenna root).
    	 * @param n Vychozi uzel.
    	 */
    	public void findRoot() {
    		VRMLNode ret=(VRMLNode)concepts.values().iterator().next();
    		
    		while(ret.parent!=null)
    			ret=ret.parent;
    		root=ret;
    	}
    	
    	public String VRMLRepresentation() {
    		return root.VRMLRepresentation(0);
    	}
    	
    	public void dump() {
    		root.dump(0);
    	}
    }
    
}
