/*
 * NonSystemConceptFilter.java
 *
 * Created on July 16, 2004, 3:19 PM
 */

package cz.cvut.km.model.iterators;

import cz.cvut.km.model.*;

/**
 * A relation iterator showing only relations not connectd to system concepts
 * @author  aubrech
 */
public class NonSystemRelationIterator extends FilterIterator {
    
    /** create a new NonSystemConceptIterator
     */
    public NonSystemRelationIterator(java.util.Iterator iter) {
        super(iter);
    }
    
    /** process only concepts not starting with "system:"
     */
    protected boolean checkObject(Object o) {
        Relation rel = (Relation)o;
        String sns = rel.getSource().getNameSpace();
        String tns = rel.getTarget().getNameSpace();
        if(sns!=null && sns.startsWith("system:"))
            return false;
        if(tns!=null && tns.startsWith("system:"))
            return false;
        return true;
    }
}
