/*
 * testGraphViz.java
 *
 * Created on May 5, 2004, 1:37 PM
 */

package cz.cvut.km.tests;

import cz.cvut.km.model.*;

import java.util.*;

/**
 * Test KB creation and export to GraphViz, runs dot to generate PS file.
 * <P>Files generated: test.dot and test.ps
 * @author  aubrech
 */
public class testBabelFishXML {
    
    /** Creates a new instance of testGraphViz */
    public testBabelFishXML() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            System.out.println("Preparing knowledge base...");
            //KnowledgeBase kb = CreateKB.createKB();
            Properties parametersFS = new Properties();
            //parametersFS.put("source","file:testdata/TestOntology.owl");
            parametersFS.put("source","file:testdata/rel-vocab-20040308.rdf");
            parametersFS.put("system-concepts","true");
            KnowledgeBase kb = new cz.cvut.km.io.OwlRdfsJena().loadKB(parametersFS);
            
            System.out.println("Saving graph to testbf.xml...");
            Properties parameters = new Properties();
            parameters.put("filename","testbf.xml");
            new cz.cvut.km.io.BabelFish().saveKB(kb, parameters);
            
            System.out.println("Loading graph from testbf.xml...");
            Properties parameters2 = new Properties();
            parameters2.put("filename","testbf.xml");
            KnowledgeBase kb2 = new cz.cvut.km.io.BabelFish().loadKB(parameters2);
            
            System.out.println("***** Diff:");
            KnowledgeBase ret = cz.cvut.km.oper.Diff.processDiff(kb,kb2);
            System.out.println("***** /Diff");
            ret.textFlush(System.out);
            
            if(ret.getConcepts().hasNext())
                System.out.println("ERROR!!!!!!!!!!!!!!!!!! Non-epmty diff between saved and loaded kb!");
            
            
            System.out.println("Done.");
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
}
