/*
 * testGraphViz.java
 *
 * Created on May 5, 2004, 1:37 PM
 */

package cz.cvut.km.tests;

import cz.cvut.km.model.*;

import java.util.*;

/**
 * Test KB creation and export to GraphViz, runs dot to generate PS file.
 * <P>Files generated: test.dot and test.ps
 * @author  aubrech
 */
public class testFiles {
    
    /** Creates a new instance of testGraphViz */
    public testFiles() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            Properties parametersFS = new Properties();
            String root = new java.io.File(".").getAbsolutePath();
            if(args.length>0)
                root = new java.io.File(args[0]).getAbsolutePath();
            String onlyDirs = "false";
            if(args.length>1)
                onlyDirs = args[1];
            System.out.println("Loading knowledge base from "+root+"...");
            
            parametersFS.put("root",root);
            parametersFS.put("onlyDirs",onlyDirs);
            KnowledgeBase kb = new cz.cvut.km.io.FileSystem().loadKB(parametersFS);
            
            AllOutputs allOutputs = new AllOutputs();
            allOutputs.export(kb);
            
            System.out.println("Done.");
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
}
