/*
 * testGraphViz.java
 *
 * Created on May 5, 2004, 1:37 PM
 */

package cz.cvut.km.tests;

import cz.cvut.km.model.*;

import java.util.*;

/**
 * Test KB creation and export to GraphViz, runs dot to generate PS file.
 * <P>Files generated: test.dot and test.ps
 * @author  aubrech
 */
public class testGraphViz {
    
    /** Creates a new instance of testGraphViz */
    public testGraphViz() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            System.out.println("Preparing knowledge base...");
            Properties parametersFS = new Properties();
            parametersFS.put("source","file:testdata/SUMO.owl");
            //parametersFS.put("source","file:testdata/rel-vocab-20040308.rdf");
            //parametersFS.put("source","file:testdata/Gentology-ont.daml");
            parametersFS.put("system-concepts","false");
            KnowledgeBase kb = new cz.cvut.km.io.OwlRdfsJena().loadKB(parametersFS);
            //KnowledgeBase kb = new cz.cvut.km.io.DAMLJena().loadKB(parametersFS);
            
            kb.textFlush(System.out);
            
            kb = cz.cvut.km.oper.Subset.createNonSystemSubset(kb);
            //kb = cz.cvut.km.oper.Subset.createSubsetByRelation(kb, SubclassOf.class);
            
            System.out.println("Saving graphs to test.dot...");
            Properties parameters = new Properties();
            parameters.put("filename","test.dot");            
            new cz.cvut.km.io.GraphViz().saveKB(kb, parameters);
            
            System.out.println("Running dot to prepare test.ps...");
            cz.cvut.km.utils.FileUtils.saveProcessOuputToFile("dot -Tps test.dot", "test.ps");
            System.out.println("Running dot to prepare test.gif...");
            cz.cvut.km.utils.FileUtils.saveProcessOuputToFile("dot -Tgif test.dot", "test.gif");
            
            System.out.println("Done.");
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
}
