/*
 * testJDBC.java
 *
 * Created on June 18, 2004, 4:00 PM
 */

package cz.cvut.km.tests;

import cz.cvut.km.model.*;
import java.util.*;

/**
 *
 * @author  aubrech
 */
public class testJDBC {
    
    /** Creates a new instance of testJDBC */
    public testJDBC() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            Properties parametersFS = new Properties();
            parametersFS.put("driver","org.postgresql.Driver");
            parametersFS.put("url","jdbc:postgresql://localhost/track");
            parametersFS.put("username",System.getProperty("user.name")); // use user's name
            parametersFS.put("password",null); // empty password -- use identity security
            parametersFS.put("system-concepts","true");
            //parametersFS.put("structureOnly","true"); -- not implemented yet
            KnowledgeBase kb = new cz.cvut.km.io.JDBC().loadKB(parametersFS);
            
            System.out.println("Saving graphs to test.dot...");
            Properties parameters = new Properties();
            parameters.put("filename","test.dot");
            new cz.cvut.km.io.GraphViz().saveKB(kb, parameters);
            
            System.out.println("Running dot to prepare test.ps...");
            cz.cvut.km.utils.FileUtils.saveProcessOuputToFile("dot -Tps test.dot", "test.ps");
            
            System.out.println("Done.");
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
}
