/*
 * testRDFS.java
 *
 * Created on June 21, 2004, 3:49 PM
 */

package cz.cvut.km.tests;

import cz.cvut.km.model.*;
import java.util.*;

/**
 *
 * @author  aubrech
 */
public class testMappingApollo {
    
    /** Creates a new instance of testRDFS */
    public testMappingApollo() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            Properties parametersFS = new Properties();
            /*
            parametersFS.put("source","file:testdata/cipher-crm.xml");
            //parametersFS.put("source","file:testdata/test-ontology.xml");
            parametersFS.put("system-concepts","false");
            KnowledgeBase kb = new cz.cvut.km.io.Apollo().loadKB(parametersFS);
             /*/
            parametersFS.put("source","file:testdata/wine.owl");
            parametersFS.put("system-concepts","true");
            KnowledgeBase kb = new cz.cvut.km.io.OwlRdfsJena().loadKB(parametersFS);
            //*/
            kb.textFlush(System.out);
            
            // Apollo not informed
            try {
                System.out.println("Saving graphs to Apollo (test.xml)...");
                // validate it is ok to save
                cz.cvut.km.io.Apollo apollo = new cz.cvut.km.io.Apollo();
                // first classify
                /*
                apollo.classifyKB(kb);
                /*/
                apollo.classifyKBByMapping(kb);
                //*/
                // then validate
                apollo.validateKB(kb);

                Properties parameters = new Properties();
                parameters.put("filename","test.xml");
                //parameters.put("prefix","sumo");
                parameters.put("prefix","");
                apollo.saveKB(kb, parameters);
            } catch(Exception e) {
                e.printStackTrace();
            }
            
            // make diff with the output
            Properties parametersFS2 = new Properties();
            parametersFS2.put("source","file:test.xml"); // output of the AllOutputs
            parametersFS2.put("system-concepts","false");
            KnowledgeBase kb2 = new cz.cvut.km.io.Apollo().loadKB(parametersFS2);
            
            System.out.println("***** Diff:");
            KnowledgeBase kbDiff = cz.cvut.km.oper.Diff.processDiff(kb,kb2);
            System.out.println("***** /Diff");
            System.out.println();
            System.out.println("============= RESULTS =============");
            System.out.println();
            kbDiff.textFlush(System.out);
            
            System.out.println("Done.");
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
}
