/*
 * testGraphViz.java
 *
 * Created on May 5, 2004, 1:37 PM
 */

package cz.cvut.km.tests;

import cz.cvut.km.model.*;

import java.util.*;

/**
 * Test KB creation and export to GraphViz, runs dot to generate PS file.
 * <P>Files generated: test.dot and test.ps
 * @author  aubrech
 */
public class testProlog {
    
    /** Creates a new instance of testGraphViz */
    public testProlog() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            System.out.println("Preparing knowledge base...");
            //KnowledgeBase kb = CreateKB.createKB();
            Properties parametersFS = new Properties();
            //parametersFS.put("source","file:testdata/SUMO.owl");
            parametersFS.put("source","file:testdata/TestOntology.owl");
            //parametersFS.put("source","file:testdata/rel-vocab-20040308.rdf");
            parametersFS.put("system-concepts","false");
            KnowledgeBase kb = new cz.cvut.km.io.OwlRdfsJena().loadKB(parametersFS);
            kb = cz.cvut.km.oper.Subset.createNonSystemSubset(kb);
            
            System.out.println("vvvvvvvvvvvvvvvvvvvvvv");
            kb.textFlush(System.out);
            System.out.println("^^^^^^^^^^^^^^^^^^^^^^");
            
            Properties parameters = new Properties();
            parameters.put("filename","test.pl");
            
            System.out.println("Saving graphs to test.pl...");
            new cz.cvut.km.io.Prolog().saveKB(kb, parameters);
            
            System.out.println("Done.");
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
}
