/*
 * testRDFS.java
 *
 * Created on June 21, 2004, 3:49 PM
 */

package cz.cvut.km.tests;

import cz.cvut.km.model.*;
import java.util.*;

/**
 * Test for translation from OWL to Apollo
 * @author aubrech
 */
public class testTransOWL2Apollo {

    /** Creates a new instance of testTransOWL2Apollo. */
    protected testTransOWL2Apollo() {
    }

    /**
     * run the transformation from OWL to Apollo
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            Properties parametersFS = new Properties();
            parametersFS.put("source","file:testdata/TrivialOntology.owl");
            //parametersFS.put("source","file:testdata/rel-vocab-20040308.rdf");
            //parametersFS.put("source","file:testdata/SUMO.owl");
            //parametersFS.put("source","file:testdata/wine.owl");
            //parametersFS.put("source","file:testdata/Government.owl");
            //parametersFS.put("source","file:testdata/TestOntology.owl");
                        
            parametersFS.put("system-concepts","false");
            parametersFS.put("nameparsing","#"); // use either # (parts/of/namespace#concept) or lastpart (parts/of/namespace/concept)
            KnowledgeBase kb = new cz.cvut.km.io.OwlRdfsJena().loadKB(parametersFS);
 
            //debug:
            System.out.println("OWL flush:");
            System.out.println("vvvvvvvvvvvvvvvvvvv");
            kb.textFlush(System.out);
            System.out.println("^^^^^^^^^^^^^^^^^^^");
            
            // validate it is ok to save
            cz.cvut.km.io.Apollo apollo = new cz.cvut.km.io.Apollo();
            
            System.out.println("Saving graphs to Apollo (test.xml)...");
            Properties parameters = new Properties();
            parameters.put("filename","wine1.xml");
            //parameters.put("filename","sumo.xml");
            //parameters.put("prefix","gov_");
            parameters.put("system-concepts","false");
            apollo.saveKB(kb, parameters);
            
            System.out.println("Done.");
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
}
