/*
 * testRDFS.java
 *
 * Created on June 21, 2004, 3:49 PM
 */

package cz.cvut.km.tests;

import cz.cvut.km.model.*;
import cz.cvut.km.model.iterators.*;
import java.util.*;
import java.io.*;

/**
 *
 * @author  aubrech
 */
public class testUnion {

    /** Creates a new instance of testRDFS. */
    protected testUnion() {
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            Properties parametersFS = new Properties();
            parametersFS.put("source", "file:testdata/test-ontology.xml");
            parametersFS.put("system-concepts", "false");
            //parametersFS.put("namespace","hist-arch");
            KnowledgeBase kb = new cz.cvut.km.io.Apollo().loadKB(parametersFS);
            kb.textFlush(System.out);

            Properties parametersFS2 = new Properties();
            parametersFS2.put("source", "file:testdata/test-ontology2.xml");
            parametersFS2.put("system-concepts", "false");
            KnowledgeBase kb2 = new cz.cvut.km.io.Apollo().loadKB(parametersFS2);
            
            System.out.println("***** Union:");
            KnowledgeBase ret = cz.cvut.km.oper.Union.processUnion(kb, kb2);
            System.out.println("***** /Union");
            ret.textFlush(System.out);

            // HTML out
            System.out.println("Saving graph to test.html...");
            Properties htmlProps = new Properties();
            htmlProps.setProperty("textbefore",
                "<p>Legend: items was found in the <span style='background:"
                + "#ffc0c0'>left</span> and <span style='background: "
                + "#c0ffc0'>right</span> knowledge base.</p>");
            htmlProps.setProperty("title", "Output of the Union function");
            //colorify according to the origin parameter
            htmlProps.setProperty("colorify", "origin");
            htmlProps.setProperty("left", "background: #ffc0c0");
            htmlProps.setProperty("right", "background: #c0ffc0");
            ret.htmlFlush(new java.io.FileOutputStream("test.html"), htmlProps);
            
            // GraphViz out
            // colorise
            Map colorMap = new HashMap();
            colorMap.put("left", "palegreen");
            colorMap.put("right", "pink");
            RelationIterator rit = ret.getRelations();
            while(rit.hasNext()) {
                Relation r = rit.nextRelation();
                String orig = r.getProperty("origin","");
                String color = (String)colorMap.get(orig);
                if(color!=null)
                    r.setProperty("color",color);
            }
            ConceptIterator cit = ret.getConcepts();
            while(cit.hasNext()) {
                Concept c = cit.nextConcept();
                String color = (String)colorMap.get(c.getProperty("origin"));
                if(color!=null)
                    c.setProperty("color", color);
            }
            System.out.println("Saving graph to testColored.dot...");
            Properties parameters = new Properties();
            parameters.put("filename","testColored.dot");            
            new cz.cvut.km.io.GraphViz().saveKB(ret, parameters);
            System.out.println("Running dot to prepare testColored.ps...");
            cz.cvut.km.utils.FileUtils.saveProcessOuputToFile("dot -Tps testColored.dot", "testColored.ps");

            AllOutputs allOutputs = new AllOutputs();
            allOutputs.export(kb);

            System.out.println("***** Done.");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
