/*
 * Apollo2Owl.java
 *
 * Created on August 19, 2004, 12:10 PM
 */

package cz.cvut.km.trans;

import cz.cvut.km.model.*;
import cz.cvut.km.model.iterators.*;
import cz.cvut.km.io.*;
import cz.cvut.km.utils.*;
import java.util.*;

/**
 * Class for informed transformation from Apollo to Owl
 * @author mzakova
 */
public class Apollo2Owl implements TransInterface {
    
    /** Creates a new instance of Apollo2Owl */
    public Apollo2Owl() {
    }
    
    public void transform(cz.cvut.km.model.KnowledgeBase kb){
        // transform types of concepts
        ConceptIterator ci = kb.getConcepts();
        while(ci.hasNext()){
            Concept concept = ci.nextConcept();
            if(Apollo.TYPE_CLASS.equals(concept.getProperty(Apollo.APPTYPE))){
                concept.setProperty(OwlJena.OWLTYPE, OwlJena.TYPE_OWL_CLASS);
            } else if (Apollo.TYPE_PROPERTY.equals(concept.getProperty(Apollo.APPTYPE))){
                concept.setProperty(OwlJena.OWLTYPE, OwlJena.TYPE_OBJECT_PROPERTY);
            } else if (Apollo.TYPE_ASSIGNMENT.equals(concept.getProperty(Apollo.APPTYPE))){
                concept.setProperty(OwlJena.OWLTYPE, OwlJena.TYPE_ASSIGNMENT);
            } else if (Apollo.TYPE_INSTANCE.equals(concept.getProperty(Apollo.APPTYPE))){
                concept.setProperty(OwlJena.OWLTYPE, OwlJena.TYPE_OWL_INSTANCE);
            } else if (Apollo.TYPE_LITERAL.equals(concept.getProperty(Apollo.APPTYPE))){
                concept.setProperty(OwlJena.OWLTYPE, OwlJena.TYPE_OWL_INSTANCE);
            }
        }
        
        //TODO: handle default values of slots
    }
}
