/*
 * DAML2Apollo.java
 *
 * Created on 29. ervenec 2004, 14:44
 */

package cz.cvut.km.trans;

import cz.cvut.km.model.*;
import cz.cvut.km.model.iterators.*;
import cz.cvut.km.io.*;
import cz.cvut.km.utils.*;
import java.util.*;

/**
 *
 * @author  jzak
 */
public class DAML2Apollo implements TransInterface {
    
    /** Creates a new instance of DAML2Apollo */
    public DAML2Apollo() {
    }
    
    public void transform(cz.cvut.km.model.KnowledgeBase kb){
        
        // transform types of concepts
        ConceptIterator ci = kb.getConcepts();
        while(ci.hasNext()){
            Concept concept = ci.nextConcept();
            if(DAMLJena.TYPE_DAML_CLASS.equals(concept.getProperty(DAMLJena.DAMLTYPE))){
                concept.setProperty(Apollo.APPTYPE, Apollo.TYPE_CLASS);
            } else if (DAMLJena.TYPE_DATATYPE_PROPERTY.equals(concept.getProperty(DAMLJena.DAMLTYPE))){
                concept.setProperty(Apollo.APPTYPE, Apollo.TYPE_PROPERTY);
            } else if (DAMLJena.TYPE_OBJECT_PROPERTY.equals(concept.getProperty(DAMLJena.DAMLTYPE))){
                concept.setProperty(Apollo.APPTYPE, Apollo.TYPE_PROPERTY);
            } else if (DAMLJena.TYPE_RESOURCE.equals(concept.getProperty(DAMLJena.DAMLTYPE))){
                concept.setProperty(Apollo.APPTYPE, Apollo.TYPE_CLASS);
                //TODO: not always true, handle properly
            } else if (DAMLJena.TYPE_RDFS_CLASS.equals(concept.getProperty(DAMLJena.DAMLTYPE))){
                concept.setProperty(Apollo.APPTYPE, Apollo.TYPE_CLASS);
            } else if (DAMLJena.TYPE_PROPERTY.equals(concept.getProperty(DAMLJena.DAMLTYPE))){
                concept.setProperty(Apollo.APPTYPE, Apollo.TYPE_PROPERTY);
            } else {
                System.out.println("ERROR! Unknown concept "+concept.getCaption());
            }
        }
    }

    
}
