package cz.cvut.km.utils;

/*
 * FromXMLFileGUI.java
 *
 * Created on 18. kv?ten 2002, 20:28
 */

import java.lang.Integer;
import java.awt.event.*;
import javax.swing.table.*;
import javax.swing.*;
import java.io.*;
import cz.cvut.sumatra2.ioUtils.*;
import cz.cvut.sumatra2.gui.schemaDesigner.textWizard.*;
import javax.swing.filechooser.FileFilter;
import cz.cvut.sumatra2.gui.ExtensionsFileFilter;

/**
 *
 * @author Petr Aubrecht
 */

public class SumatraToGUI extends javax.swing.JFrame {
    private ParamVector paramVector;
    
    /** Creates new form ShowData */
    public SumatraToGUI(ParamVector paramVector) {
        this.paramVector=paramVector;
        initComponents();
        String filePath=paramVector.getParamValue("filename");
        if (filePath==null) {
            textFieldFilePath.setText("");
        }
        else {
            textFieldFilePath.setText(filePath);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        labelCaption = new javax.swing.JLabel();
        textFieldFilePath = new javax.swing.JTextField();
        btnChooseFile = new javax.swing.JButton();
        panelActionButtons = new javax.swing.JPanel();
        btnOk = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setTitle("Set module properties");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        labelCaption.setText("Target file");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 5, 5);
        getContentPane().add(labelCaption, gridBagConstraints);

        textFieldFilePath.setText("jTextField1");
        textFieldFilePath.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 5, 5);
        getContentPane().add(textFieldFilePath, gridBagConstraints);

        btnChooseFile.setText("...");
        btnChooseFile.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnChooseFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnChooseFileActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        getContentPane().add(btnChooseFile, gridBagConstraints);

        panelActionButtons.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 10, 5));

        btnOk.setText("Ok");
        btnOk.setPreferredSize(new java.awt.Dimension(75, 26));
        btnOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOkActionPerformed(evt);
            }
        });

        panelActionButtons.add(btnOk);

        btnCancel.setText("Cancel");
        btnCancel.setPreferredSize(new java.awt.Dimension(75, 26));
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        panelActionButtons.add(btnCancel);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(panelActionButtons, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-400)/2, (screenSize.height-199)/2, 400, 199);
    }//GEN-END:initComponents

    private void btnOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOkActionPerformed
        paramVector.setParamValue("filename",textFieldFilePath.getText());
        dispose();
    }//GEN-LAST:event_btnOkActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        dispose();
    }//GEN-LAST:event_btnCancelActionPerformed

    private void btnChooseFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnChooseFileActionPerformed
        JFileChooser fileChooser=new JFileChooser();
        File file=new File(textFieldFilePath.getText());
        if (file.exists()) {
            fileChooser.setCurrentDirectory(file.getParentFile());
        }
        String[] ext = (new String("xml,xsl,dtd,xsum,form")).split(",");
        ExtensionsFileFilter myFilter = new ExtensionsFileFilter("XML Files", ext);
        fileChooser.setFileFilter(myFilter);
        
        fileChooser.showOpenDialog(this);
        file=fileChooser.getSelectedFile();
        if (file!=null) {
            textFieldFilePath.setText(file.getPath());
        }            
    }//GEN-LAST:event_btnChooseFileActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        dispose();
    }//GEN-LAST:event_exitForm

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnChooseFile;
    private javax.swing.JButton btnOk;
    private javax.swing.JLabel labelCaption;
    private javax.swing.JPanel panelActionButtons;
    private javax.swing.JTextField textFieldFilePath;
    // End of variables declaration//GEN-END:variables

}
